scala.tools.nsc.transform.patmat.MatchTreeMaking.TreeMakers

# ProductExtractorTreeMaker

###
Related Doc: package TreeMakers

#### case class ProductExtractorTreeMaker(prevBinder: Global.Symbol, extraCond: Option[Global.Tree])(subPatBinders: List[Global.Symbol], subPatRefs: List[Global.Tree], mutableBinders: List[Global.Symbol], binderKnownNonNull: Boolean, ignoredSubPatBinders: Set[Global.Symbol]) extends FunTreeMaker with PreserveSubPatBinders with Product with Serializable

An optimized version of ExtractorTreeMaker for Products. For now, this is hard-coded to case classes, and we simply extract the case class fields.

The values for the subpatterns, as specified by the case class fields at the time of extraction, are stored in local variables that re-use the symbols in `subPatBinders`. This makes extractor patterns more debuggable (SI-5739) as well as avoiding mutation after the pattern has been matched (SI-5158, SI-6070)

TODO: make this user-definable as follows When a companion object defines a method `def unapply_1(x: T): U_1`, but no `def unapply` or `def unapplySeq`, the extractor is considered to match any non-null value of type T the pattern is expected to have as many sub-patterns as there are `def unapply_I(x: T): U_I` methods, and the type of the I'th sub-pattern is `U_I`. The same exception for Seq patterns applies: if the last extractor is of type `Seq[U_N]`, the pattern must have at least N arguments (exactly N if the last argument is annotated with `: _*`). The arguments starting at N (and beyond) are taken from the sequence returned by apply_N, and it is checked that that sequence has enough elements to provide values for all expected sub-patterns.

For a case class C, the implementation is assumed to be `def unapply_I(x: C) = x._I`, and the extractor call is inlined under that assumption.

Source
  MatchTreeMaking.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, PreserveSubPatBinders, FunTreeMaker, TreeMaker, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ProductExtractorTreeMaker
2. Serializable
3. Serializable
4. Product
5. Equals
6. PreserveSubPatBinders
7. FunTreeMaker
8. TreeMaker
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ProductExtractorTreeMaker(prevBinder: Global.Symbol, extraCond: Option[Global.Tree])(subPatBinders: List[Global.Symbol], subPatRefs: List[Global.Tree], mutableBinders: List[Global.Symbol], binderKnownNonNull: Boolean, ignoredSubPatBinders: Set[Global.Symbol])

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ProductExtractorTreeMaker to any2stringadd[ProductExtractorTreeMaker] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ProductExtractorTreeMaker, B)

   Implicit information
     This member is added by an implicit conversion from ProductExtractorTreeMaker to ArrowAssoc[ProductExtractorTreeMaker] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def bindSubPats(in: Global.Tree): Global.Tree

   Definition Classes
     PreserveSubPatBinders

8. #### def chainBefore(next: Global.Tree)(casegen: TreeMakers.Casegen): Global.Tree

   Definition Classes
     ProductExtractorTreeMaker → TreeMaker

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @HotSpotIntrinsicCandidate() @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### def emitVars: Boolean

    Definition Classes
      PreserveSubPatBinders

11. #### def ensuring(cond: (ProductExtractorTreeMaker) ⇒ Boolean, msg: ⇒ Any): ProductExtractorTreeMaker

    Implicit information
      This member is added by an implicit conversion from ProductExtractorTreeMaker to Ensuring[ProductExtractorTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (ProductExtractorTreeMaker) ⇒ Boolean): ProductExtractorTreeMaker

    Implicit information
      This member is added by an implicit conversion from ProductExtractorTreeMaker to Ensuring[ProductExtractorTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): ProductExtractorTreeMaker

    Implicit information
      This member is added by an implicit conversion from ProductExtractorTreeMaker to Ensuring[ProductExtractorTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): ProductExtractorTreeMaker

    Implicit information
      This member is added by an implicit conversion from ProductExtractorTreeMaker to Ensuring[ProductExtractorTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### val extraCond: Option[Global.Tree]

17. #### def extraStoredBinders: Set[Global.Symbol]

    Definition Classes
      ProductExtractorTreeMaker → PreserveSubPatBinders

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ProductExtractorTreeMaker to StringFormat[ProductExtractorTreeMaker] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

20. #### val ignoredSubPatBinders: Set[Global.Symbol]

    Definition Classes
      ProductExtractorTreeMaker → PreserveSubPatBinders

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### lazy val localSubstitution: TreeMakers.Substitution

    Attributes
      protected
    Definition Classes
      PreserveSubPatBinders → TreeMaker

23. #### val mutableBinders: List[Global.Symbol]

24. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

25. #### val nextBinder: Global.Symbol

    Definition Classes
      ProductExtractorTreeMaker → FunTreeMaker

26. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

27. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

28. #### def pos: Global.Position

    Definition Classes
      FunTreeMaker → TreeMaker

29. #### val prevBinder: Global.Symbol

30. #### lazy val storedBinders: Set[Global.Symbol]

    Definition Classes
      PreserveSubPatBinders

31. #### val subPatBinders: List[Global.Symbol]

    Definition Classes
      ProductExtractorTreeMaker → PreserveSubPatBinders

32. #### val subPatRefs: List[Global.Tree]

    Definition Classes
      ProductExtractorTreeMaker → PreserveSubPatBinders

33. #### def subPatternsAsSubstitution: TreeMakers.Substitution

    The substitution that specifies the trees that compute the values of the subpattern binders.

    The substitution that specifies the trees that compute the values of the subpattern binders.

    We pretend to replace the subpattern binders by subpattern refs (Even though we don't do so anymore -- see SI-5158, SI-5739 and SI-6070.)

    Definition Classes
      PreserveSubPatBinders → TreeMaker

34. #### def substitution: TreeMakers.Substitution

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

    Definition Classes
      TreeMaker

35. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

36. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      ProductExtractorTreeMaker → AnyRef → Any

37. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### def →[B](y: B): (ProductExtractorTreeMaker, B)

    Implicit information
      This member is added by an implicit conversion from ProductExtractorTreeMaker to ArrowAssoc[ProductExtractorTreeMaker] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from PreserveSubPatBinders

### Inherited from FunTreeMaker

### Inherited from TreeMaker

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ProductExtractorTreeMaker to any2stringadd[ProductExtractorTreeMaker]

### Inherited by implicit conversion StringFormat from ProductExtractorTreeMaker to StringFormat[ProductExtractorTreeMaker]

### Inherited by implicit conversion Ensuring from ProductExtractorTreeMaker to Ensuring[ProductExtractorTreeMaker]

### Inherited by implicit conversion ArrowAssoc from ProductExtractorTreeMaker to ArrowAssoc[ProductExtractorTreeMaker]

### Ungrouped